unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, FileCtrl,
  ExtCtrls, Buttons, StdCtrls, EditBtn;

type

  { TForm1 }

  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    DirectoryEdit1: TDirectoryEdit;
    FileListBox1: TFileListBox;
    Label1: TLabel;
    Panel1: TPanel;
    ScrollBox1: TScrollBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure DirectoryEdit1AcceptDirectory(Sender: TObject; var Value: String);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  i,px,py:integer;
  NewImage:TImage;
  NewLabel:TLabel;
begin
  px:=0;
  py:=0;
  // Die FilstList Box durchgehen
  for i:=0 to FileListBox1.Items.Count-1 do begin
    // Bei 100 aufhören, kann auskomentiert werden
    if i = 100 then exit;
    // Eine Image Komponente erstellen und Konfiguieren.
    NewImage:=TImage.Create(ScrollBox1);
    NewImage.Picture.LoadFromFile(FileListBox1.Directory+DirectorySeparator+FileListBox1.Items[i]);
    NewImage.Parent:=ScrollBox1;
    NewImage.Left:=px;
    NewImage.Top:=py;
    // Ein Label erstellen und Konfiguieren
    NewLabel:=TLabel.Create(ScrollBox1);
    NewLabel.Parent:=ScrollBox1;
    NewLabel.AutoSize:=False;
    NewLabel.Caption:=FileListBox1.Items[i];
    NewLabel.Left:=px;
    NewLabel.Top:=py+NewImage.Height+2;
    NewLabel.Width:=NewImage.Width;
    NewLabel.Height:=20;
    // Für einen Automatischen Zeilenumbruch
    if px+NewImage.Width+5 >=ScrollBox1.Width-NewImage.Width then begin
      px:=0;
      py:=py+NewImage.Height+20; // Ein Abstand von 20 Pixel haben die einzelnen "Spalten"
    end
    else
      px:=px+NewImage.Width+5; // Ein Abstand von 5 Pixel haben die Spalten zu einander
  end;
end;

procedure TForm1.DirectoryEdit1AcceptDirectory(Sender: TObject;
  var Value: String);
begin
    FileListBox1.Directory:=Value;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DirectoryEdit1.Directory:=FileListBox1.Directory;
end;

end.

